
(defun C:ARCSOL  ()
(prompt "Give Text Style: - 1. Microgramma; 2. Helvetica; 3. Futura;  " )
(setq sty (getstring "\nKey 1, 2 or 3 : "))
(if (= sty "1") (wid1))
(if (= sty "2") (wid2))
(if (= sty "3") (wid3))
(if ho (progn
    (setq h (getreal (strcat "\nGive Character Height <" (rtos ho) "> : ")))
    (if (= h nil) (setq h ho)))
    (setq h (getreal "\nGive Character Height: ")))
  (setq ho h)
(if p0o (progn
    (setq p0 (getpoint (strcat "\nGive Center Point: <" (rtos (car p0o) 2 2)
                                     "," (rtos (cadr p0o) 2 2) "> : ")))
    (if (= p0 nil) (setq p0 p0o)))
    (setq p0 (getpoint "\nGive Center Point: ")))
  (setq p0o p0)
(if p1o (progn
    (setq p1 (getpoint (strcat "\nGive Start Point: <" (rtos (car p1o) 2 2)
                                      "," (rtos (cadr p1o) 2 2) "> : ")))
    (if (= p1 nil) (setq p1 p1o)))
    (setq p1 (getpoint "\nGive Start Point: ")))
  (setq p1o p1)
(if dno (progn
    (setq dn (getstring (strcat "\nClockwise or Anticlockwise <" dno "> : ")))
    (if (= dn "" ) (setq dn dno)))
  (setq dn (getstring "\nClockwise or Anticlockwise <C> : ")))
  (if (= dn "" ) (setq dn "C"))
  (setq dno dn)
(if w1o (progn
    (setq w1 (getreal (strcat "\nWidth Factor <" (rtos w1o 2 2) "> : ")))
    (if (= w1 nil) (setq w1 w1o)))
  (setq w1 (getreal "\nWidth Factor <1> : ")))
  (if (= w1 nil) (setq w1 1.0))
  (setq w1o w1)
(if s1o (progn
    (setq s1 (getreal (strcat "\nSpacing Adjustment <" (rtos s1o 2 2) "> : ")))
    (if (= s1 nil) (setq s1 s1o)))
  (setq s1 (getreal "\nSpacing Adjustment <0> : ")))
  (if (= s1 nil) (setq s1 0))
  (setq s1o s1)
(setq tex "\nKey Text: ")
(if texo (progn
    (setq tex (strcat tex "<" texo "> : "))
    (setq tex (getstring  tex "n\Key Tex : "))
    (if (= tex "") (setq tex texo)))
  (setq tex (getstring tex "Key Text: ")))
  (setq texo tex)
(setvar "cmdecho" 0)
(setvar "highlight" 0)
(setvar "blipmode" 0)
(prompt "Loading Character Library.....")
(command "insert" (strcat pre "lib") "0,0" 1 1 0)
(setq l (strlen tex))
(setq n 1)
(setq wfo 0)
(setq ang (angle p0 p1))
(setq r (distance p0 p1))
(while (<= n l)
    (setq tx (substr tex n 1))
    (setq i (strcat pre (itoa (ascii tx))))
    (setq wf1 (/ (nth (- (ascii tx) 31) wid) 100.0))
    (setq wf (/ (+ wf1 wfo) 2.0))
    (setq w3 (* (/ (- wf1 0.2) 2.0) w1 h))
    (setq w2 (*  w1 h))
    (setq w (* (+ wf s1) w1 h))
(if (= (strcase dn) "A") (progn
       (if (= n 1) (setq ang1 (+ ang (/ w3 r))) (setq ang1 (+ ang (/ w r))))
       (setq rot (+ (* ang1 (/ 180 pi)) 90))
       (setq p3 (polar p0 (- ang1 (/ w3 r)) r)))
       (progn
       (if (= n 1) (setq ang1 (- ang (/ w3 r))) (setq ang1 (- ang (/ w r))))
       (setq rot (- (* ang1 (/ 180 pi)) 90))
       (setq p3 (polar p0 (+ ang1 (/ w3 r)) r)))
  )
    (command "insert" i p3 w2 h rot)
    (setq n (1+ n))
    (setq ang ang1)
    (setq wfo wf1)
    )
(setvar "highlight" 1)
(setvar "blipmode" 1)
(setvar "cmdecho" 1)
(princ)
)

(defun wid1 ()
(setq pre "1dec")
(setq wid (list 0 100 50 80 140 140 140 160 50 65 65 105 105 50 105 50 105
140 92 140 140 145 135 135 130 140 135 50 50 55 65 55 120 140 170 145 150 150
125 125 150 150 50 120 150 120 180 150 150 140 165 140 140 135 150 170 220 160
160 140 ))
)

(defun wid3 ()
(setq pre "3dec")
(setq wid (list 0 100 40 70 98 70 115 98 40 60 60 83 83 40 83 40 83 98 70 83 83
98 89 98 89 89 98 40 40 60 83 60 83 140 121 89 113 105 83 83 121 98 40 70 98 77
121 105 121 89 140 89 89 98 105 113 160 121 105 98 60 80 60 77 121 40 92 92 92
92 92 70 92 83 40 60 83 40 121 83 92 92 92 60 70 60 92 92 128 98 92 77 ))
)

(defun wid2 ()
(setq pre "2dec")
(setq wid (list 0 100 40 80 86 108 115 98 40 60 60 83 83 40 83 40 83 102 65 92 9
96 98 98 86 95 98 40 40 60 83 60 89 140 118 105 113 110 96 96 115 104 40 90
110 94 126 110 120 98 120 99 108 98 108 118 156 120 110 98 60 80 60 77 121 40 85
 92 89 92 92 57 92 87 34 45 87 34 133 87 92 92 92 51 81 57 87 89 128 95 90 77 )
)
)

