; **********************************************************************
(defun chgterr (G)
   (if (/= G "Function cancelled")   ; If an error (such as CTRL-C) occurs
      (princ (strcat "\nError: " G)) ; while this command is active...
   )
   (setq *error* olderr)             ; Restore old *error* handler
   (princ)
)

(defun c:dat (/ n s si z ns e olderr)

(SETVAR "USERI5" 1)

(defun tes1 ()
;--------------        
	(IF (= si 1)
	   (setq ns 202)
	   (progn
	     (if (or
		   (= (substr s (1- si) 1) "`")
		   (= (substr s (1- si) 1) "]")
		   (= (substr s (1- si) 1) ".")
		   (= (substr s (1- si) 1) ",")
		   (= (substr s (1- si) 1) "V")
		   (= (substr s (1- si) 1) "C")
		   (= (substr s (1- si) 1) "H")
		   (= (substr s (1- si) 1) "B")
		   (= (substr s (1- si) 1) (chr 32))
		   (= (substr s (1- si) 1) (chr 162))
		   (= (substr s (1- si) 1) (chr 163))
		   (= (substr s (1- si) 1) (chr 177))
		   (= (substr s (1- si) 1) (chr 176))
		  )
	       (setq ns 202)
		(progn (if (or
			   (= si psl)
			   (= (substr s (1+ si) 1) (chr 32))
			   )
			   (setq ns 240)
			   (setq ns 220)
		)
	       )
	     )
	   )
	  )
	      (if (= ns 202)
	       (progn 
		   (if (or
			(= si psl)
			(= (substr s (1+ si) 1) (chr 32))
		       )
		       (setq ns 230)
		    )
		)
	      )
);end func tes1
;---------------- 

;Processing Starts here
;----------------------

(setq olderr  *error*             ; Initialize variables
      *error* chgterr)
;(setq pt (getpoint "\nSTART POINT"))
(TERPRI)
;(prompt "TEXT :")
;(setq s (read-line))

 (setq midsty "KUFI2")
 (setq fy "n")
 (setq sty (getvar "textstyle"))
 
 
 (if (= sty "ARABHOL1") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABNAS3") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABNAS2") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABISO1") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABKOF1") (setq fy "y") (setq fn "n") )

 (if (= fy "n") 
    (progn
    (prompt "\nPlease Select Arabic Style  First .....!.\n")
    (quit)
    )
 )
 
 
 (setq ptx (getpoint "Select point for start of Text:"))
 (command "TEXT" ptx "" "z")
 (command "erase" "L" "")
 (setq ht  (getvar "textsize"))
 
 ;(Command "Style" "Kufi2" "kufi2" ht 1 0 "N" "N" )
 
 (Command "Style" midsty midsty ht 1 0 "N" "N" )
 (setq styx midsty)
 (Command "dtext" ptx "" ) 

 (setq en (entlast))           ; Entity name
 
 (if (= en nil)
    (progn 
    (prompt "\nNo Arabic Text found .... !.\n")
    (setvar "textstyle" sty)
    (setq cn 1)
    (quit)
    )
 )
 
 (setq ed (entget en))         ; Entity Data
 (setq et (cdr (assoc 0 ed)))  ; Entity Type

 (if (= et "TEXT")
    (progn
    (setq pt   (cdr (assoc 10 ed)))  ; Text Insertion Point
    (setq s    (cdr (assoc 1  ed)))  ; Text Value
    (setq styx (cdr (assoc 7  ed)))  ; Text Style
    )
 )

 (if (= styx sty)
    (progn 
    (prompt "\nNo Arabic Text found .... !.\n")
    (setvar "textstyle" sty)
    (setq cn 1)
    (quit)
    )
 )
 
 (if (and (= styx sty ) (/= styx midsty) )
    (progn
       (prompt "\nNo Arabic Text found .... !.\n")
       (setvar "textstyle" sty)
       (setq cn 2) 
       (quit) 
    )
 )
 
 
 (if (and (/= styx sty ) (/= styx midsty) )
    (progn
      (prompt "\nNo Arabic Text found .... !.\n")
      (setvar "textstyle" sty)
      (setq cn 3)
      (quit) 
    )
 )
 
 (setq s (strcase s))
 (setq psl (strlen s))
 (setq si 1)
 (setq z "")
   
 (while (<= si psl)
     (tes1)
     (setq z (strcat z (CHR ns) (substr s si 1)))
     (setq si (1+ si))
 )

 (setvar "textstyle" sty)   
 (command "erase" "L" "")
 (COMMAND "TEXT" pt "" z)
 (terpri)
 (setq *error* olderr)             ; Restore old *error* handler
 (princ)
   
);endfun c:dat
