; **********************************************************************
(defun chgterr (G)
   (if (/= G "Function cancelled")   ; If an error (such as CTRL-C) occurs
      (princ (strcat "\nError: " G)) ; while this command is active...
   )
   (setq *error* olderr)             ; Restore old *error* handler
   (princ)
)

(defun c:mat (/ n s si z ns e olderr)

(SETVAR "USERI5" 1)

(defun tes1 ()
;--------------        
	(IF (= si 1)
	   (setq ns 202)
	   (progn
	     (if (or
		   (= (substr s (1- si) 1) "`")
		   (= (substr s (1- si) 1) "]")
		   (= (substr s (1- si) 1) ".")
		   (= (substr s (1- si) 1) ",")
		   (= (substr s (1- si) 1) "V")
		   (= (substr s (1- si) 1) "C")
		   (= (substr s (1- si) 1) "H")
		   (= (substr s (1- si) 1) "B")
		   (= (substr s (1- si) 1) (chr 32))
		   (= (substr s (1- si) 1) (chr 162))
		   (= (substr s (1- si) 1) (chr 163))
		   (= (substr s (1- si) 1) (chr 177))
		   (= (substr s (1- si) 1) (chr 176))
		  )
	       (setq ns 202)
		(progn (if (or
			   (= si psl)
			   (= (substr s (1+ si) 1) (chr 32))
			   )
			   (setq ns 240)
			   (setq ns 220)
		)
	       )
	     )
	   )
	  )
	      (if (= ns 202)
	       (progn 
		   (if (or
			(= si psl)
			(= (substr s (1+ si) 1) (chr 32))
		       )
		       (setq ns 230)
		    )
		)
	      )
);end func tes1
;---------------- 

;Processing Starts here
;----------------------

(setq olderr  *error*             ; Initialize variables
      *error* chgterr)
;(setq pt (getpoint "\nSTART POINT"))
(TERPRI)
;(prompt "TEXT :")
;(setq s (read-line))

(setq cl (getvar "clayer" )) ; Current active layer.
(setq cr (getvar "cecolor")) ; Current active color.

(setq ss (entsel "Select Arabic Text to Edit:"))            ; Select one Object
(setq en (car ss))            ; Entity name
(setq ed (entget en))         ; Entity Data
(setq et (cdr (assoc 0 ed)))  ; Entity Type

(if (= et "TEXT")
   (progn
   (setq pt  (cdr (assoc 10 ed)))   ; Text Insertion Point
   (setq stx (cdr (assoc 1 ed)))    ; Text Value
   (setq sty (cdr (assoc 7 ed)))    ; Text Style 
   (setq ht (cdr (assoc 40 ed)))    ; Text height (size)
   
   )
)

 (setq psl (strlen stx))
 (setq sti 2)
 (setq zx "")
   
 (while (<= sti psl)
    (setq zx (strcat zx  (substr stx sti 1)))
    (setq sti (+ sti 2))
 )
 
 (Command "Style"  "Kufi2" "kufi2" ht 1 0 "N" "N" )
 ;(command "erase"  "L" "")
 (Command "Color" "250")
 (Command "text"   pt "" zx)
 (Command "ddedit" "L" pause)
 
 ; Select Last Object:
 (setq en (entlast))           ; Entity name
 (setq ed (entget en))         ; Entity Data
 (setq et (cdr (assoc 0 ed)))  ; Entity Type

 (if (= et "TEXT")
    (progn
    (setq pt  (cdr (assoc 10 ed)))   ; Text Insertion Point
    (setq s (cdr (assoc 1 ed)))      ; Text Value
    )
 )

 (setq s (strcase s))
 (setq psl (strlen s))
 (setq si 1)
 (setq z "")
   
 (while (<= si psl)
      (tes1)
      (setq z (strcat z (CHR ns) (substr s si 1)))
      (setq si (1+ si))
 )
 
 (setvar "textstyle" sty)   
 ;(Command "Style" "--font name--" "" "" "" "" "" "" )
 
 (command "erase" "L" "")
 (command "erase" "L" "") 
 (command "color" "bylayer")
 (COMMAND "TEXT" pt "" z)
 (terpri)
 (setq *error* olderr)             ; Restore old *error* handler
 (princ)
   

 
);end fun c:mat
