 (prompt "\nPlease...Wait the program is being loaded...\n")
(vmon)
    (defun C:SOLTEX ()
 (setvar "BLIPMODE" 0)
(setq h (getreal "Give Character Height: "))
(setq wd (getreal "Give Character Width Factor <1>: "))
(if (= wd nil) (setq wd 1))
(setq wc (* wd h))
(prompt "Give Text Style: - 1. Microgramma; 2. Helvetica; 3. Futura;  " )
(terpri)
(setq sty (getstring "Key 1, 2 or 3 : "))
(if (= sty "1") (wid1))
(if (= sty "2") (wid2))
(if (= sty "3") (wid3))
(terpri)
(setq p (getpoint "Give L.H.B. point: "))
(terpri)
(setq tex "Key Text : ")
(setq tex (getstring tex "Key Tex : "))
(setq l (strlen tex))
(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(if (and (> h 1.7) (/= sty "1") (/= wd 1)) (progn
    (setq wd 1)
    (prompt "**Width Factor only applies for text less than 1.7")))
    (terpri)
(prompt "Loading Character Library.....")
(command "insert" (strcat pre "lib") "0,0" 1 1 0)
(setq ltr (list "A" "L"))
(setq ltl (list "A" "J"))
(setq lbr (list "F" "P" "7" "T" "V" "W" "Y"))
(setq lbl (list "1" "T" "V" "W" "Y"))
(pltext)
(setvar "cmdecho" 1)
(setvar "blipmode" 0)
(cmdprompt)
)


    (defun pltext ()
(setq n 1)
(setq tl (chr 31))
    (while (<= n l)
(setq tx (substr tex n 1 ))
(if (or (> 32 (ascii tx)) (< 90 (ascii tx))) (progn
      (if (= sty "1") (setq tx " "))
      (if (= sty "1") (prompt "**Undefined Character**"))
    ))
(setq i (strcat pre (itoa (ascii tx))))
(setq wf ( / (nth (- (ascii tl) 31) wid) 100.00))
(if (and (member tl ltr) (member tx lbl)) (setq wf (- wf 0.2)))
(if (and (member tl lbr) (member tx ltl)) (setq wf (- wf 0.2)))
(setq w (* wf h wd))
(setq p (list (+ (car p) w) (cadr p)))
(if (and (> h 1.7) (/= sty "1")) (progn
        (setq i (strcat "*" i))
        (command "insert" i p h 0))
    (command "insert" i p wc h 0)
)
(setq tl tx)
(setq n (+ n 1))
    )
 )

(defun wid1 ()
(setq pre "1dec")
(setq wid (list 0 100 50 80 140 140 140 160 50 65 65 105 105 50 105 50 105
140 92 140 140 145 135 135 130 140 135 50 50 55 65 55 120 140 170 145 150 150
125 125 150 150 50 120 150 120 180 150 150 140 165 140 140 135 150 170 220 160
160 140 ))
)

(defun wid3 ()
(setq pre "3dec")
(setq wid (list 0 100 40 70 98 70 115 98 40 60 60 83 83 40 83 40 83 98 70 83 83
98 89 98 89 89 98 40 40 60 83 60 83 140 121 89 113 105 83 83 121 98 40 70 98 77
121 105 121 89 140 89 89 98 105 113 160 121 105 98 60 80 60 77 121 40 92 92 92
92 92 70 92 83 40 60 83 40 121 83 92 92 92 60 70 60 92 92 128 98 92 77 ))
)

(defun wid2 ()
(setq pre "2dec")
(setq wid (list 0 100 40 80 86 108 115 98 40 60 60 83 83 40 83 40 83 102 65 92
96 96 98 98 86 95 98 40 40 60 83 60 89 140 118 105 113 110 96 96 115 104 40 90
110 94 126 110 120 98 120 99 108 98 108 118 156 120 110 98 60 80 60 77 121 40 85
 92 89 92 92 57 92 87 34 45 87 34 133 87 92 92 92 51 81 57 87 89 128 95 90 77 )
)
)
(defun C:ENDSOL ()
(setq pd nil)
(setq fyle nil)
(setq v (atoi (substr (ver) 18)))
(if (>= v 2 )(setq pd (getvar "pdmode")))
(if (/= pd nil) (setvar "pdmode" 0))
(if (>= v 2 )(setq fyle (getvar "dwgname"))
                (setq fyle (getstring "Give file name - <No extension> : ")))
(setvar "cmdecho" 0)
(command "zoom" "w" "-.01,-.01" ".01,.01" )
(command "erase" "w" "-.01,-.01" ".01,.01" "")
(command "zoom" "p")
(if (/= pd nil) (setvar "pdmode" pd))
(setq f (open (strcat fyle ".dwg") "r"))
(if (= f nil) (command "wblock" fyle "*"))
(if (/= f nil) (command "wblock" fyle "y" "*"))
(command "quit" "y")
)




(defun C:TEXTIN ()
(setvar "cmdecho" 0)
(setq name (getstring "Key Text File Name <Include Extension> : "))
(if (= name "" ) (cmdprompt))
(setq fyle (open name "r"))
    (while (= fyle nil)
    (setq name (getstring "File Not Found - KEY FULL FILE NAME! : "))
    (if (= name "") (cmdprompt))
    (setq fyle (open name "r")))
(setq bl (getstring "Batch or Line Input : Key B or L <B> : "))
(if (= bl "") (setq bl "B"))
(setq style (getstring "Give Text Style <Must Be in File> : "))
(if (= style "") (cmdprompt))
(setq h (getreal "Key Text Height <2.5> : "))
(if (= h nil) (setq h 2.5))
(if (or (= bl "L") (= bl "l")) () (setq sp (getreal "Key Line Spacing <5>: ")))
(if (= sp nil) (setq sp 5.0))
(setq rot (getreal "Key Text Rotation <0> : "))
(if (= rot nil) (setq rot 0.0))
(setq ang (- rot 90))
(setq ang (* pi (/ ang 180.0)))
(setq l (read-line fyle))
    (if (or (= bl "L") (= bl "l")) (linein) (batchin))
(close fyle)
(setvar "cmdecho" 1)
(setvar "blipmode" 1)
(terpri)
(cmdprompt)
)
(defun batchin ()
(setq p (getpoint "Give Location Point  : "))
(setvar "blipmode" 0)
    (while (/= l nil)
    (command "text" "s" style p h rot l)
    (setq p (polar p ang sp))
    (setq l (read-line fyle)))
)
(defun linein ()
    (while (/= l nil)
    (prompt l)
    (setq p (getpoint "\nGive Location Point : "))
    (terpri)
    (command "text" "s" style p h rot l)
    (setq l (read-line fyle)))
 )
(defun cmdprompt ()
    (defun *error* (st)
        (setq *error* nil)
        (princ))
(quit)
)

(defun C:KERNTEX ()
(setq style (getstring "Give Text Style: "))
(setq h (getreal "Give Character Height: "))
(setq rot (getreal "Give Character Rotation <0>: "))
(if (= rot nil) (setq rot 0))
(setq p (getpoint "Give L.H.B. point: "))
(terpri)
(setq tex "Key Text : ")
(setq tex (getstring tex  "Key Text  : "))
(setvar "cmdecho" 0)
(setq tx (substr tex 1 1))
(setq l (strlen tex))
(setq ltr (list "A" "L"))
(setq ltl (list "A" "J"))
(setq lbr (list "F" "P" "7" "T" "V" "W" "Y"))
(setq lbl (list "1" "T" "V" "W" "Y"))
(setq n 2)
(setq tf tx)
(setq tl tx)
(while  (<= n l)
 (setq tx (substr tex n 1 ))
 (setq tz tx)
 (if (and (member tl ltr) (member tx lbl)) (setq tx (strcat "%%200" tx)))
 (if (and (member tl lbr) (member tx ltl)) (setq tx (strcat "%%200" tx)))
 (setq tf (strcat tf tx ))
 (setq tl tz)
 (setq n (+ n 1))
 )
(command "text" "s" style p h rot tf)
(setvar "cmdecho" 1)
(cmdprompt)
)
 (c:soltex)
