; ******************* CAT.lsp **********************************************

(defun chgterr (G)
   (if (/= G "Function cancelled")   ; If an error (such as CTRL-C) occurs
      (princ (strcat "\nError: " G)) ; while this command is active...
   )
   (setq *error* olderr)             ; Restore old *error* handler
   (princ)
)

(defun c:cat (/ n s si z ns e olderr)

(SETVAR "USERI5" 1)

(defun tes1 ()
	(IF (= si 1)
	   (setq ns 202)
	   (progn
	     (if (or
		   (= (substr s (1- si) 1) "`")
		   (= (substr s (1- si) 1) "]")
		   (= (substr s (1- si) 1) ".")
		   (= (substr s (1- si) 1) ",")
		   (= (substr s (1- si) 1) "V")
		   (= (substr s (1- si) 1) "C")
		   (= (substr s (1- si) 1) "H")
		   (= (substr s (1- si) 1) "B")
		   (= (substr s (1- si) 1) (chr 32))
		   (= (substr s (1- si) 1) (chr 162))
		   (= (substr s (1- si) 1) (chr 163))
		   (= (substr s (1- si) 1) (chr 177))
		   (= (substr s (1- si) 1) (chr 176))
		  )
	       (setq ns 202)
		(progn (if (or
			   (= si psl)
			   (= (substr s (1+ si) 1) (chr 32))
			   )
			   (setq ns 240)
			   (setq ns 220)
		)
	       )
	     )
	   )
	  )
	      (if (= ns 202)
	       (progn 
		   (if (or
			(= si psl)
			(= (substr s (1+ si) 1) (chr 32))
		       )
		       (setq ns 230)
		    )
		)
	      )
);end func tes1
 
(setq olderr  *error*             ; Initialize variables
      *error* chgterr)
;(setq pt (getpoint "\nSTART POINT"))
(TERPRI)
;(prompt "TEXT :")
;(setq s (read-line))

 (setq fy "n")
 (setq sty (getvar "textstyle"))
 (setq ht  (getvar "textsize"))
 
 (if (= sty "ARABHOL1") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABNAS3") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABNAS2") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABISO1") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABKOF1") (setq fy "y") (setq fn "n") )

 (if (= fy "n") 
    (progn
      (prompt "Please Select Arabic Style  First .....!.")
      (quit)
    );progn
 ); end if

 (setq selset (ssget))
 (setq count 0)

 (while (< count (sslength selset))
   
   (setq en (ssname selset count)) ; Entity name
   (setq ed (entget en))            ; Entity Data
   (setq et (cdr (assoc 0 ed)))    ; Entity Type
   
   (if (= et "TEXT")
      (progn
      (setq pt (cdr (assoc 10 ed)))   ; Text Insertion Point
      (setq s (cdr (assoc 1 ed)))     ; Text Value
      (setq ht (cdr (assoc 40 ed)))    ; Text height (size)
      (setq rt (cdr (assoc 50 ed)))    ; Rotation angle (size)   
      (setq rt (* rt (/ 180 pi) ) )
      );progn
   );end if
   
   (setq s (strcase s))
   (setq psl (strlen s))
   (setq si 1)
   (setq z "")
   
   (while (<= si psl)
	(tes1)
	(setq z (strcat z (CHR ns) (substr s si 1)))
	(setq si (1+ si))
   );end while

   (COMMAND "TEXT" pt rt z)
   (terpri)
   (setq *error* olderr)             ; Restore old *error* handler
   (princ)
   
   (setq count (1+ count))

 );end while selset
 
 (COMMAND "ERASE" "P" "")

);end fun c:TT
