; **********************************************************************
(defun chgterr (G)
   (if (/= G "Function cancelled")   ; If an error (such as CTRL-C) occurs
      (princ (strcat "\nError: " G)) ; while this command is active...
   )
   (setq *error* olderr)             ; Restore old *error* handler
   (princ)
)

(defun c:nat (/ n s si z ns e olderr)

(SETVAR "USERI5" 1)


;Processing Starts here
;----------------------

 (setq olderr  *error*             ; Initialize variables
       *error* chgterr)
 (TERPRI)

 (setq fy "n")
 (setq sty (getvar "textstyle"))
 
 
 (if (= sty "ARABHOL1") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABNAS3") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABNAS2") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABISO1") (setq fy "y") (setq fn "n") )
 (if (= sty "ARABKOF1") (setq fy "y") (setq fn "n") )

 (if (= fy "n") 
    (progn
    (prompt "\nPlease Select Arabic Style  First .....!.\n")
    (quit)
    )
 )
 
 
 (setq ptx (getpoint "Select point for start of Text:"))
 (command "TEXT" ptx "" "z")
 (command "erase" "L" "")
 (setq ht  (getvar "textsize"))
 
 (if ( NULL (tblsearch "style" "NAT") )
    (Command "Style" "NAT" "SIMPLEX" ht 1 0 "N" "N" "N" )
 )
 
 (setvar "textstyle" "NAT")
 
 (Command "dtext" ptx "" ) 

 (setvar "textstyle" sty)
 
 (terpri)
 (setq *error* olderr)             ; Restore old *error* handler
 (princ)
   
);endfun c:nat
